Client-side Call Home on TLS
Client » Client-side Call Home

TLS settings for the Call Home functionality. More...

Collaboration diagram for Client-side Call Home on TLS:

## Functions

int | nc_client_tls_ch_add_bind_listen (const char *address, uint16_t port)
| Add a new client bind and start listening on it for TLS Call Home connections. More...
int | nc_client_tls_ch_del_bind (const char *address, uint16_t port)
| Remove a TLS listening client bind. More...
void | nc_client_tls_ch_get_cert_key_paths (const char **client_cert, const char **client_key)
| Get client Call Home authentication identity - a certificate and a private key. More...
void | nc_client_tls_ch_get_crl_paths (const char **crl_file, const char **crl_dir)
| Get client Call Home Certificate Revocation Lists. More...
void | nc_client_tls_ch_get_trusted_ca_paths (const char **ca_file, const char **ca_dir)
| Get client Call Home trusted CA certificates. More...
int | nc_client_tls_ch_set_cert_key_paths (const char *client_cert, const char *client_key)
| Set client Call Home authentication identity - a certificate and a private key. More...
int | nc_client_tls_ch_set_crl_paths (const char *crl_file, const char *crl_dir)
| Set client Call Home Certificate Revocation Lists. More...
int | nc_client_tls_ch_set_trusted_ca_paths (const char *ca_file, const char *ca_dir)
| Set client Call Home trusted CA certificates. More...

## Detailed Description

TLS settings for the Call Home functionality.

## Function Documentation

## nc_client_tls_ch_add_bind_listen()

int nc_client_tls_ch_add_bind_listen | ( | const char * | address,
|  | uint16_t | port
| ) |  |

Add a new client bind and start listening on it for TLS Call Home connections.

Parameters

  [in] | address | IP address to bind to.
  [in] | port | Port to bind to.

Returns
  0 on success, -1 on error.

## nc_client_tls_ch_del_bind()

int nc_client_tls_ch_del_bind | ( | const char * | address,
|  | uint16_t | port
| ) |  |

Remove a TLS listening client bind.

Parameters

  [in] | address | IP address the socket was bound to. NULL matches all.
  [in] | port | Port the socket was bound to. 0 matches all.

Returns
  0 on success, -1 on not found.

## nc_client_tls_ch_get_cert_key_paths()

void nc_client_tls_ch_get_cert_key_paths | ( | const char ** | client_cert,
|  | const char ** | client_key
| ) |  |

Get client Call Home authentication identity - a certificate and a private key.

Parameters

  [out] | client_cert | Path to the file containing the client certificate. Can be NULL.
  [out] | client_key | Path to the file containing the private key for the `client_cert`. Can be NULL.

## nc_client_tls_ch_get_crl_paths()

void nc_client_tls_ch_get_crl_paths | ( | const char ** | crl_file,
|  | const char ** | crl_dir
| ) |  |

Get client Call Home Certificate Revocation Lists.

Parameters

  [out] | crl_file | Location of the CRL certificate file used to check for revocated certificates. Can be NULL.
  [out] | crl_dir | Location of the CRL certificate directory used to check for revocated certificates. Can be NULL.

## nc_client_tls_ch_get_trusted_ca_paths()

void nc_client_tls_ch_get_trusted_ca_paths | ( | const char ** | ca_file,
|  | const char ** | ca_dir
| ) |  |

Get client Call Home trusted CA certificates.

Parameters

  [out] | ca_file | Location of the CA certificate file used to verify server certificates. Can be NULL.
  [out] | ca_dir | Location of the CA certificates directory used to verify the server certificates. Can be NULL.

## nc_client_tls_ch_set_cert_key_paths()

int nc_client_tls_ch_set_cert_key_paths | ( | const char * | client_cert,
|  | const char * | client_key
| ) |  |

Set client Call Home authentication identity - a certificate and a private key.

Parameters

  [in] | client_cert | Path to the file containing the client certificate.
  [in] | client_key | Path to the file containing the private key for the `client_cert`. If NULL, key is expected to be stored with `client_cert`.

Returns
  0 on success, -1 on error.

## nc_client_tls_ch_set_crl_paths()

int nc_client_tls_ch_set_crl_paths | ( | const char * | crl_file,
|  | const char * | crl_dir
| ) |  |

Set client Call Home Certificate Revocation Lists.

Parameters

  [in] | crl_file | Location of the CRL certificate file used to check for revocated certificates.
  [in] | crl_dir | Location of the CRL certificate directory used to check for revocated certificates.

Returns
  0 on success, -1 on error.

## nc_client_tls_ch_set_trusted_ca_paths()

int nc_client_tls_ch_set_trusted_ca_paths | ( | const char * | ca_file,
|  | const char * | ca_dir
| ) |  |

Set client Call Home trusted CA certificates.

Parameters

  [in] | ca_file | Location of the CA certificate file used to verify server certificates. For more info, see the documentation for SSL_CTX_load_verify_locations() from OpenSSL.
  [in] | ca_dir | Location of the CA certificates directory used to verify the server certificates. For more info, see the documentation for SSL_CTX_load_verify_locations() from OpenSSL.

Returns
  0 on success, -1 on error.